controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::class,
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::class,
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }


    public function actionEjercicio1()
    {
        $alumnos = [
            'Miguel',
            'Maria',
            'Pedro',
            'Samuel',
        ];

        return $this->render('ejercicio1', ['alumnos' => $alumnos]);
    }



    public function actionEjercicio2b()
    {
        $fotos = [
            'alumno1.png',
            'alumno2.png',
            'alumno3.png',
            'alumno4.png',
        ];
        return $this->render('ejercicio2b', ['imagenes' => $fotos]);
    }

    public function actionEjercicio2a()
    {
        $fotos = [
            'alumno1.png',
            'alumno2.png',
            'alumno3.png',
            'alumno4.png',
        ];
        return $this->render('ejercicio2a', ['imagenes' => $fotos]);
    }

    public function actionEjercicio3($id = 0)
    {
        $alumnos = [
            [
                "nombre" => "Miguel",
                "poblacion" => "Santander",
                "imagen" => "alumno1.png"
            ],
            [
                "nombre" => "Maria",
                "poblacion" => "Laredo",
                "imagen" => "alumno2.png"
            ],
            [
                "nombre" => "Pedro",
                "poblacion" => "Cartes",
                "imagen" => "alumno3.png"
            ],
            [
                "nombre" => "Samuel",
                "poblacion" => "Santander",
                "imagen" => "alumno4.png"
            ],
        ];
        //quito la imagen en el array alumno para utilizarlo en el widget
        $alumnoSinFoto = $alumnos[$id];
        unset($alumnoSinFoto["imagen"]);
        return $this->render('ejercicio3', [
            "alumno" => $alumnos[$id],
            "alumnoSinFoto" => $alumnoSinFoto
        ]);
    }

    public function actionEjercicio4()
    {
        $numeros = [1, 2, 3, 4, 5, 6, 7, 8, 9, 10];
        return $this->render('ejercicio4', ['numeros' => $numeros]);
    }

    public function actionEjercicio5()
    {
        $datos = [
            [
                "id" => "1",
                "nombre" => "Miguel",
                "poblacion" => "Santander",
                "direccion" => "Calle 1",
            ],
            [
                "id" => "2",
                "nombre" => "Maria",
                "poblacion" => "Laredo",
                "direccion" => "Calle 2",
            ],
            [
                "id" => "3",
                "nombre" => "Pedro",
                "poblacion" => "Cartes",
                "direccion" => "Calle 3",
            ],
            [
                "id" => "4",
                "nombre" => "Samuel",
                "poblacion" => "Santander",
                "direccion" => "Calle 4",
            ],
        ];
        //quiero que en vista se muestren los datos anteriores
        //utilizando cards
        //en el titulo de la card se coloca el id
        //en el texto de la card se coloca el nombre
        //el resto de los campos en una lista dentro de la card
        //con el formato NombreValor:Valor

        return $this->render('ejercicio5', ['datos' => $datos]);
    }


    public function actionEjercicio6()
    {
        $datos = [
            [
                "id" => "1",
                "nombre" => "Miguel",
                "poblacion" => "Santander",
                "direccion" => "Calle 1",
            ],
            [
                "id" => "2",
                "nombre" => "Maria",
                "poblacion" => "Laredo",
                "direccion" => "Calle 2",
            ],
            [
                "id" => "3",
                "nombre" => "Pedro",
                "poblacion" => "Cartes",
                "direccion" => "Calle 3",
            ],
            [
                "id" => "4",
                "nombre" => "Samuel",
                "poblacion" => "Santander",
                "direccion" => "Calle 4",
            ],
        ];
        //quiero que en vista se muestren los datos anteriores
        //utilizando cards
        //en el titulo de la card se coloca el id
        //en el texto de la card se coloca el nombre
        //el resto de los campos en una lista dentro de la card
        //con el formato NombreValor:Valor
        //utilizando subvistas (realizar el render de la vista)

        return $this->render('ejercicio6', ['datos' => $datos]);
    }
}

views/layouts/main.php
<?php

/** @var yii\web\View $this */
/** @var string $content */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap5\Breadcrumbs;
use yii\bootstrap5\Html;
use yii\bootstrap5\Nav;
use yii\bootstrap5\NavBar;

AppAsset::register($this);

$this->registerCsrfMetaTags();
$this->registerMetaTag(['charset' => Yii::$app->charset], 'charset');
$this->registerMetaTag(['name' => 'viewport', 'content' => 'width=device-width, initial-scale=1, shrink-to-fit=no']);
$this->registerMetaTag(['name' => 'description', 'content' => $this->params['meta_description'] ?? '']);
$this->registerMetaTag(['name' => 'keywords', 'content' => $this->params['meta_keywords'] ?? '']);
$this->registerLinkTag(['rel' => 'icon', 'type' => 'image/x-icon', 'href' => Yii::getAlias('@web/favicon.ico')]);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">

<head>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>

<body class="d-flex flex-column h-100">
    <?php $this->beginBody() ?>

    <header id="header">
        <?php
        NavBar::begin([
            'brandLabel' => Yii::$app->name,
            'brandUrl' => Yii::$app->homeUrl,
            'options' => ['class' => 'navbar-expand-md navbar-dark bg-dark fixed-top']
        ]);
        echo Nav::widget([
            'options' => ['class' => 'navbar-nav'],
            'items' => [
                ['label' => 'Home', 'url' => ['/site/index']],
                ['label' => 'Ejercicio1', 'url' => ['/site/ejercicio1']],
                ['label' => 'Ejercicio2', 'items' => [
                    ['label' => 'Ejercicio2a', 'url' => ['/site/ejercicio2a']],
                    ['label' => 'Ejercicio2b', 'url' => ['/site/ejercicio2b']],
                ]],
                ['label' => 'Ejercicio3', 'items' => [
                    ['label' => 'Alumno1', 'url' => ['/site/ejercicio3', 'id' => 0]],
                    ['label' => 'Alumno2', 'url' => ['/site/ejercicio3', 'id' => 1]],
                    ['label' => 'Alumno3', 'url' => ['/site/ejercicio3', 'id' => 2]],
                    ['label' => 'Alumno4', 'url' => ['/site/ejercicio3', 'id' => 3]],
                ]],
                ['label' => 'Ejercicio4', 'url' => ['/site/ejercicio4']],
                ['label' => 'Ejercicio5', 'url' => ['/site/ejercicio5']],
                ['label' => 'Ejercicio6', 'url' => ['/site/ejercicio6']],
            ]
        ]);
        NavBar::end();
        ?>
    </header>

    <main id="main" class="flex-shrink-0" role="main">
        <div class="container">
            <?php if (!empty($this->params['breadcrumbs'])) : ?>
                <?= Breadcrumbs::widget(['links' => $this->params['breadcrumbs']]) ?>
            <?php endif ?>
            <?= Alert::widget() ?>
            <?= $content ?>
        </div>
    </main>

    <footer id="footer" class="mt-auto py-3 bg-light">
        <div class="container">
            <div class="row text-muted">
                <div class="col-md-6 text-center text-md-start">&copy; My Company <?= date('Y') ?></div>
                <div class="col-md-6 text-center text-md-end"><?= Yii::powered() ?></div>
            </div>
        </div>
    </footer>

    <?php $this->endBody() ?>
</body>

</html>
<?php $this->endPage() ?>

views/site/_ejercicio6Item.php
  <div class="col-sm-3">
      <div class="card">
          <div class="card-header">
              <h3 class="card-title">Id: <?= $dato["id"] ?></h3>
          </div>
          <div class="card-body">
              <p class="card-text">Nombre: <?= $dato["nombre"] ?></p>
          </div>
          <ul class=" list-group list-group-flush">
              <li class="list-group-item">Poblacion: <?= $dato["poblacion"] ?></li>
              <li class="list-group-item">Direccion: <?= $dato["direccion"] ?></li>
          </ul>
      </div>
  </div>

views/site/_elemento.php
<li class="list-group-item"><?= $numero ?></li>

views/site/_listado.php
<ul class="list-group list-group-horizontal">
    <?php
    foreach ($numeros as $numero) {
        echo $this->render("_elemento", [
            "numero" => $numero
        ]);
    }

    ?>
</ul>

views/site/ejercicio1.php
<?php

use yii\helpers\Html;

echo "<h1>Ejercicio 1</h1>";

echo Html::ul($alumnos);

views/site/ejercicio2a.php
<?php

use yii\helpers\Html;

echo "<h1>Ejercicio 2</h1>";

echo "<h3>Con Helper ul</h3>";
echo Html::ul(
    $imagenes,
    [
        'class' => 'list-group list-group-horizontal',
        "item" => function ($imagen) {
            $salida = "<li class='list-group-item col-lg-3'>";
            $salida .= Html::img("@web/imgs/{$imagen}",[
                    'class' => 'img-thumbnail',
                ]
            );
            $salida .= "</li>";
            return $salida;
        },
    ]
);

views/site/ejercicio2b.php
<?php

use yii\helpers\Html;

echo "<h1>Ejercicio 2</h1>";

echo "<h3>Con foreach</h3>";
echo "<ul class='list-group list-group-horizontal'>";
foreach ($imagenes as $imagen) {
    echo "<li class='list-group-item col-lg-3'>";
    echo Html::img("@web/imgs/{$imagen}", [
        'class' => 'img-thumbnail',
    ]);
    echo "</li>";
}
echo "</ul>";

views/site/ejercicio3.php
<?php

use yii\helpers\Html;

echo "<h1>Ejercicio 3</h1>";

//Sin utilizar los helpers
?>

<div class="row">
    <div class="card">
        <div class="col-sm-3">
            <img src="<?= Yii::getAlias("@web") ?>/imgs/<?= $alumno["imagen"] ?>">
            <div class="card-body">
                <p> Nombre: <?= $alumno["nombre"] ?></p>
                <p>Poblacion: <?= $alumno["poblacion"] ?></p>
            </div>
        </div>
    </div>
</div>




<?php

//Utilizando helpers	

?>

<div class="row">
    <div class="col-sm-3">
        <div class="card">
            <?= Html::img("@web/imgs/" . $alumno["imagen"], ["class" => "card-img-top"]) ?>
            <?= Html::ul($alumnoSinFoto, [
                "class" => "list-group list-group-flush",
                "itemOptions" => [
                    "class" => "list-group-item"
                ],
                // "item" => function ($dato, $indice) {
                //     $salida = "";
                //     if ($indice != "imagen") {
                //         $salida .= "<li class='list-group-item'>{$indice}: {$dato}</li>";
                //     }
                //     return $salida;
                // }

            ]) ?>
        </div>
    </div>
</div>

views/site/ejercicio4.php
<?php

use yii\helpers\Html;

echo "<h1>Ejercicio 4</h1>";


 // con el helper ul
echo Html::ul($numeros, [
    "class" => "list-group list-group-horizontal",
    "itemOptions" => [
        "class" => "list-group-item",
    ],
]);

echo "<br>";
echo "<hr>";
echo "<br>";

//renderizando todos los elementos
//con subvistas
echo $this->render('_listado', [
    'numeros' => $numeros
]);

echo "<br>";
echo "<hr>";
echo "<br>";

//sin cargar vistas
?>

<ul class="list-group list-group-horizontal">
    <?php
    foreach ($numeros as $numero) {
        echo '<li class="list-group-item">' . $numero . '</li>';
    }
    ?>
</ul>

views/site/ejercicio5.php
<?php

// $salida = "<div class='row'>";
// $salida .= "<div class='col-sm-6'>";
// foreach ($datos as $indice => $dato) {
//     $salida .= "<h5 class='card-title'>" . $dato["id"] . ".</h5>";
//     $salida .= "<p class='card-text'>" . $dato["nombre"] . "</p>";
//     $salida .= "<ul>";
//     foreach ($dato as $indice => $valor) {
//         if ($indice != "id" && $indice != "nombre") {
//             $salida .= "<li class='list-group-item'>" . $indice . ": " . $valor . "</li>";
//         }
//         $salida .= "</ul>";
//     }
// }
// $salida .= "</div>";
// $salida .= "</div>";

// echo $salida;


//opcion 2
?>
<div class="row">
    <?php
    foreach ($datos as $dato) {
    ?>
        <div class="col-sm-3">
            <div class="card">
                <div class="card-header">
                    <h3 class="card-title">Id: <?= $dato["id"] ?></h3>
                </div>
                <div class="card-body">
                    <p class="card-text">Nombre: <?= $dato["nombre"] ?></p>
                </div>
                <ul class=" list-group list-group-flush">
                    <li class="list-group-item">Poblacion: <?= $dato["poblacion"] ?></li>
                    <li class="list-group-item">Direccion: <?= $dato["direccion"] ?></li>
                </ul>
            </div>
        </div>
    <?php
    }
    ?>
</div>

views/site/ejercicio6.php
<?php

// sin utilizar Helpers de HTML

use yii\helpers\Html;

// echo "<div class='row'>";
echo Html::beginTag('div', ['class' => 'row']);
foreach ($datos as $dato) {
    echo $this->render("_ejercicio6Item", ['dato' => $dato]);
}

echo Html::endTag('div');
// echo "</div>";

views/site/error.php
<?php

/** @var yii\web\View $this */
/** @var string $name */
/** @var string $message */
/** @var Exception$exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/** @var yii\web\View $this */

$this->title = 'Aplicacion2';
?>
<div class="site-index">

    <div class="jumbotron text-center bg-transparent mt-5 mb-5">
        <h1 class="display-4">Pagina de inicio</h1>